import { DlzControlTowerControlFormat, IDlzControlTowerControl, DlzControlTowerStandardControls } from '../index';
/**
 * Detect if the EBS volumes that are attached to an Amazon EC2 instance are encrypted.
 *
 * Format: Legacy Control
 * https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#ebs-enable-encryption
 */
export declare class AWS_GR_ENCRYPTED_VOLUMES implements IDlzControlTowerControl {
    readonly controlFriendlyName = DlzControlTowerStandardControls['AWS_GR_ENCRYPTED_VOLUMES'];
    readonly description = "Detect if the EBS volumes that are attached to an Amazon EC2 instance are encrypted.";
    readonly format = DlzControlTowerControlFormat.LEGACY;
    readonly externalLink = "https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#ebs-enable-encryption";
    readonly controlIdName: {
        euWest1: string;
        usEast1: string;
    };
}
