import { DlzControlTowerControlFormat, IDlzControlTowerControl, DlzControlTowerStandardControls } from '../index';
/**
 * Detect unrestricted connectivity to remote console services such as SSH.
 *
 * Format: Legacy Control
 * https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#ssh-disallow-internetz
 */
export declare class AWS_GR_RESTRICTED_SSH implements IDlzControlTowerControl {
    readonly controlFriendlyName = DlzControlTowerStandardControls['AWS_GR_RESTRICTED_SSH'];
    readonly description = "Detect unrestricted connectivity to remote console services such as SSH.";
    readonly format = DlzControlTowerControlFormat.LEGACY;
    readonly externalLink = "https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#ssh-disallow-internet";
    readonly controlIdName: {
        euWest1: string;
        usEast1: string;
    };
}
