import { DlzControlTowerControlFormat, IDlzControlTowerControl, DlzControlTowerStandardControls } from '../index';
/**
 * Detect whether root user has Multi-Factor Authentication (MFA) enabled.
 *
 * Format: Legacy Control
 * https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#enable-root-mfa
 */
export declare class AWS_GR_ROOT_ACCOUNT_MFA_ENABLED implements IDlzControlTowerControl {
    readonly controlFriendlyName = DlzControlTowerStandardControls['AWS_GR_ROOT_ACCOUNT_MFA_ENABLED'];
    readonly description = "Detect whether root user has Multi-Factor Authentication (MFA) enabled.";
    readonly format = DlzControlTowerControlFormat.LEGACY;
    readonly externalLink = "https://docs.aws.amazon.com/controltower/latest/userguide/strongly-recommended-controls.html#enable-root-mfa";
    readonly controlIdName: {
        euWest1: string;
        usEast1: string;
    };
}
