import { Construct } from 'constructs';
export declare class DlzSsmReader {
    /**
     * Get the value of an SSM Parameter Store value.
     *
     * Fetch type `always` will always fetch the value from SSM Parameter Store, this will produce a CDK diff every time.
     * Fetch type `value-change` will fetch the value from SSM Parameter Store only when the value changes, this will not
     * produce a CDK diff every time.
     *
     * @param scope
     * @param id
     * @param accountId
     * @param region
     * @param name
     * @param withDecryption
     * @param fetchType
     */
    static getValue(scope: Construct, id: string, accountId: string, region: string, name: string, fetchType?: 'always' | 'value-change', withDecryption?: boolean): string;
}
