import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_ProvideAnomalyFeedbackCommand, se_ProvideAnomalyFeedbackCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class ProvideAnomalyFeedbackCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSInsightsIndexService", "ProvideAnomalyFeedback", {})
    .n("CostExplorerClient", "ProvideAnomalyFeedbackCommand")
    .f(void 0, void 0)
    .ser(se_ProvideAnomalyFeedbackCommand)
    .de(de_ProvideAnomalyFeedbackCommand)
    .build() {
}
