import { ExceptionOptionType as __ExceptionOptionType } from "@smithy/smithy-client";
import { CostExplorerServiceException as __BaseException } from "./CostExplorerServiceException";
export declare const AccountScope: {
  readonly LINKED: "LINKED";
  readonly PAYER: "PAYER";
};
export type AccountScope = (typeof AccountScope)[keyof typeof AccountScope];
export interface AnomalyScore {
  MaxScore: number | undefined;
  CurrentScore: number | undefined;
}
export declare const AnomalyFeedbackType: {
  readonly NO: "NO";
  readonly PLANNED_ACTIVITY: "PLANNED_ACTIVITY";
  readonly YES: "YES";
};
export type AnomalyFeedbackType =
  (typeof AnomalyFeedbackType)[keyof typeof AnomalyFeedbackType];
export interface Impact {
  MaxImpact: number | undefined;
  TotalImpact?: number | undefined;
  TotalActualSpend?: number | undefined;
  TotalExpectedSpend?: number | undefined;
  TotalImpactPercentage?: number | undefined;
}
export interface RootCause {
  Service?: string | undefined;
  Region?: string | undefined;
  LinkedAccount?: string | undefined;
  UsageType?: string | undefined;
  LinkedAccountName?: string | undefined;
}
export interface Anomaly {
  AnomalyId: string | undefined;
  AnomalyStartDate?: string | undefined;
  AnomalyEndDate?: string | undefined;
  DimensionValue?: string | undefined;
  RootCauses?: RootCause[] | undefined;
  AnomalyScore: AnomalyScore | undefined;
  Impact: Impact | undefined;
  MonitorArn: string | undefined;
  Feedback?: AnomalyFeedbackType | undefined;
}
export interface AnomalyDateInterval {
  StartDate: string | undefined;
  EndDate?: string | undefined;
}
export declare const MonitorDimension: {
  readonly SERVICE: "SERVICE";
};
export type MonitorDimension =
  (typeof MonitorDimension)[keyof typeof MonitorDimension];
export declare const MatchOption: {
  readonly ABSENT: "ABSENT";
  readonly CASE_INSENSITIVE: "CASE_INSENSITIVE";
  readonly CASE_SENSITIVE: "CASE_SENSITIVE";
  readonly CONTAINS: "CONTAINS";
  readonly ENDS_WITH: "ENDS_WITH";
  readonly EQUALS: "EQUALS";
  readonly GREATER_THAN_OR_EQUAL: "GREATER_THAN_OR_EQUAL";
  readonly STARTS_WITH: "STARTS_WITH";
};
export type MatchOption = (typeof MatchOption)[keyof typeof MatchOption];
export interface CostCategoryValues {
  Key?: string | undefined;
  Values?: string[] | undefined;
  MatchOptions?: MatchOption[] | undefined;
}
export declare const Dimension: {
  readonly AGREEMENT_END_DATE_TIME_AFTER: "AGREEMENT_END_DATE_TIME_AFTER";
  readonly AGREEMENT_END_DATE_TIME_BEFORE: "AGREEMENT_END_DATE_TIME_BEFORE";
  readonly ANOMALY_TOTAL_IMPACT_ABSOLUTE: "ANOMALY_TOTAL_IMPACT_ABSOLUTE";
  readonly ANOMALY_TOTAL_IMPACT_PERCENTAGE: "ANOMALY_TOTAL_IMPACT_PERCENTAGE";
  readonly AZ: "AZ";
  readonly BILLING_ENTITY: "BILLING_ENTITY";
  readonly CACHE_ENGINE: "CACHE_ENGINE";
  readonly DATABASE_ENGINE: "DATABASE_ENGINE";
  readonly DEPLOYMENT_OPTION: "DEPLOYMENT_OPTION";
  readonly INSTANCE_TYPE: "INSTANCE_TYPE";
  readonly INSTANCE_TYPE_FAMILY: "INSTANCE_TYPE_FAMILY";
  readonly INVOICING_ENTITY: "INVOICING_ENTITY";
  readonly LEGAL_ENTITY_NAME: "LEGAL_ENTITY_NAME";
  readonly LINKED_ACCOUNT: "LINKED_ACCOUNT";
  readonly LINKED_ACCOUNT_NAME: "LINKED_ACCOUNT_NAME";
  readonly OPERATING_SYSTEM: "OPERATING_SYSTEM";
  readonly OPERATION: "OPERATION";
  readonly PAYMENT_OPTION: "PAYMENT_OPTION";
  readonly PLATFORM: "PLATFORM";
  readonly PURCHASE_TYPE: "PURCHASE_TYPE";
  readonly RECORD_TYPE: "RECORD_TYPE";
  readonly REGION: "REGION";
  readonly RESERVATION_ID: "RESERVATION_ID";
  readonly RESOURCE_ID: "RESOURCE_ID";
  readonly RIGHTSIZING_TYPE: "RIGHTSIZING_TYPE";
  readonly SAVINGS_PLANS_TYPE: "SAVINGS_PLANS_TYPE";
  readonly SAVINGS_PLAN_ARN: "SAVINGS_PLAN_ARN";
  readonly SCOPE: "SCOPE";
  readonly SERVICE: "SERVICE";
  readonly SERVICE_CODE: "SERVICE_CODE";
  readonly SUBSCRIPTION_ID: "SUBSCRIPTION_ID";
  readonly TENANCY: "TENANCY";
  readonly USAGE_TYPE: "USAGE_TYPE";
  readonly USAGE_TYPE_GROUP: "USAGE_TYPE_GROUP";
};
export type Dimension = (typeof Dimension)[keyof typeof Dimension];
export interface DimensionValues {
  Key?: Dimension | undefined;
  Values?: string[] | undefined;
  MatchOptions?: MatchOption[] | undefined;
}
export interface TagValues {
  Key?: string | undefined;
  Values?: string[] | undefined;
  MatchOptions?: MatchOption[] | undefined;
}
export declare const MonitorType: {
  readonly CUSTOM: "CUSTOM";
  readonly DIMENSIONAL: "DIMENSIONAL";
};
export type MonitorType = (typeof MonitorType)[keyof typeof MonitorType];
export declare const AnomalySubscriptionFrequency: {
  readonly DAILY: "DAILY";
  readonly IMMEDIATE: "IMMEDIATE";
  readonly WEEKLY: "WEEKLY";
};
export type AnomalySubscriptionFrequency =
  (typeof AnomalySubscriptionFrequency)[keyof typeof AnomalySubscriptionFrequency];
export declare const SubscriberStatus: {
  readonly CONFIRMED: "CONFIRMED";
  readonly DECLINED: "DECLINED";
};
export type SubscriberStatus =
  (typeof SubscriberStatus)[keyof typeof SubscriberStatus];
export declare const SubscriberType: {
  readonly EMAIL: "EMAIL";
  readonly SNS: "SNS";
};
export type SubscriberType =
  (typeof SubscriberType)[keyof typeof SubscriberType];
export interface Subscriber {
  Address?: string | undefined;
  Type?: SubscriberType | undefined;
  Status?: SubscriberStatus | undefined;
}
export declare const ApproximationDimension: {
  readonly RESOURCE: "RESOURCE";
  readonly SERVICE: "SERVICE";
};
export type ApproximationDimension =
  (typeof ApproximationDimension)[keyof typeof ApproximationDimension];
export interface ResourceTag {
  Key: string | undefined;
  Value: string | undefined;
}
export interface CreateAnomalyMonitorResponse {
  MonitorArn: string | undefined;
}
export declare class LimitExceededException extends __BaseException {
  readonly name: "LimitExceededException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<LimitExceededException, __BaseException>
  );
}
export interface CreateAnomalySubscriptionResponse {
  SubscriptionArn: string | undefined;
}
export declare class UnknownMonitorException extends __BaseException {
  readonly name: "UnknownMonitorException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<UnknownMonitorException, __BaseException>
  );
}
export declare const CostCategoryInheritedValueDimensionName: {
  readonly LINKED_ACCOUNT_NAME: "LINKED_ACCOUNT_NAME";
  readonly TAG: "TAG";
};
export type CostCategoryInheritedValueDimensionName =
  (typeof CostCategoryInheritedValueDimensionName)[keyof typeof CostCategoryInheritedValueDimensionName];
export interface CostCategoryInheritedValueDimension {
  DimensionName?: CostCategoryInheritedValueDimensionName | undefined;
  DimensionKey?: string | undefined;
}
export declare const CostCategoryRuleType: {
  readonly INHERITED_VALUE: "INHERITED_VALUE";
  readonly REGULAR: "REGULAR";
};
export type CostCategoryRuleType =
  (typeof CostCategoryRuleType)[keyof typeof CostCategoryRuleType];
export declare const CostCategoryRuleVersion: {
  readonly CostCategoryExpressionV1: "CostCategoryExpression.v1";
};
export type CostCategoryRuleVersion =
  (typeof CostCategoryRuleVersion)[keyof typeof CostCategoryRuleVersion];
export declare const CostCategorySplitChargeMethod: {
  readonly EVEN: "EVEN";
  readonly FIXED: "FIXED";
  readonly PROPORTIONAL: "PROPORTIONAL";
};
export type CostCategorySplitChargeMethod =
  (typeof CostCategorySplitChargeMethod)[keyof typeof CostCategorySplitChargeMethod];
export declare const CostCategorySplitChargeRuleParameterType: {
  readonly ALLOCATION_PERCENTAGES: "ALLOCATION_PERCENTAGES";
};
export type CostCategorySplitChargeRuleParameterType =
  (typeof CostCategorySplitChargeRuleParameterType)[keyof typeof CostCategorySplitChargeRuleParameterType];
export interface CostCategorySplitChargeRuleParameter {
  Type: CostCategorySplitChargeRuleParameterType | undefined;
  Values: string[] | undefined;
}
export interface CostCategorySplitChargeRule {
  Source: string | undefined;
  Targets: string[] | undefined;
  Method: CostCategorySplitChargeMethod | undefined;
  Parameters?: CostCategorySplitChargeRuleParameter[] | undefined;
}
export interface CreateCostCategoryDefinitionResponse {
  CostCategoryArn?: string | undefined;
  EffectiveStart?: string | undefined;
}
export declare class ServiceQuotaExceededException extends __BaseException {
  readonly name: "ServiceQuotaExceededException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<ServiceQuotaExceededException, __BaseException>
  );
}
export interface DeleteAnomalyMonitorRequest {
  MonitorArn: string | undefined;
}
export interface DeleteAnomalyMonitorResponse {}
export interface DeleteAnomalySubscriptionRequest {
  SubscriptionArn: string | undefined;
}
export interface DeleteAnomalySubscriptionResponse {}
export declare class UnknownSubscriptionException extends __BaseException {
  readonly name: "UnknownSubscriptionException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<UnknownSubscriptionException, __BaseException>
  );
}
export interface DeleteCostCategoryDefinitionRequest {
  CostCategoryArn: string | undefined;
}
export interface DeleteCostCategoryDefinitionResponse {
  CostCategoryArn?: string | undefined;
  EffectiveEnd?: string | undefined;
}
export declare class ResourceNotFoundException extends __BaseException {
  readonly name: "ResourceNotFoundException";
  readonly $fault: "client";
  Message?: string | undefined;
  ResourceName?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<ResourceNotFoundException, __BaseException>
  );
}
export interface DescribeCostCategoryDefinitionRequest {
  CostCategoryArn: string | undefined;
  EffectiveOn?: string | undefined;
}
export declare const CostCategoryStatusComponent: {
  readonly COST_EXPLORER: "COST_EXPLORER";
};
export type CostCategoryStatusComponent =
  (typeof CostCategoryStatusComponent)[keyof typeof CostCategoryStatusComponent];
export declare const CostCategoryStatus: {
  readonly APPLIED: "APPLIED";
  readonly PROCESSING: "PROCESSING";
};
export type CostCategoryStatus =
  (typeof CostCategoryStatus)[keyof typeof CostCategoryStatus];
export interface CostCategoryProcessingStatus {
  Component?: CostCategoryStatusComponent | undefined;
  Status?: CostCategoryStatus | undefined;
}
export declare const NumericOperator: {
  readonly BETWEEN: "BETWEEN";
  readonly EQUAL: "EQUAL";
  readonly GREATER_THAN: "GREATER_THAN";
  readonly GREATER_THAN_OR_EQUAL: "GREATER_THAN_OR_EQUAL";
  readonly LESS_THAN: "LESS_THAN";
  readonly LESS_THAN_OR_EQUAL: "LESS_THAN_OR_EQUAL";
};
export type NumericOperator =
  (typeof NumericOperator)[keyof typeof NumericOperator];
export interface TotalImpactFilter {
  NumericOperator: NumericOperator | undefined;
  StartValue: number | undefined;
  EndValue?: number | undefined;
}
export interface GetAnomaliesRequest {
  MonitorArn?: string | undefined;
  DateInterval: AnomalyDateInterval | undefined;
  Feedback?: AnomalyFeedbackType | undefined;
  TotalImpact?: TotalImpactFilter | undefined;
  NextPageToken?: string | undefined;
  MaxResults?: number | undefined;
}
export interface GetAnomaliesResponse {
  Anomalies: Anomaly[] | undefined;
  NextPageToken?: string | undefined;
}
export declare class InvalidNextTokenException extends __BaseException {
  readonly name: "InvalidNextTokenException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<InvalidNextTokenException, __BaseException>
  );
}
export interface GetAnomalyMonitorsRequest {
  MonitorArnList?: string[] | undefined;
  NextPageToken?: string | undefined;
  MaxResults?: number | undefined;
}
export interface GetAnomalySubscriptionsRequest {
  SubscriptionArnList?: string[] | undefined;
  MonitorArn?: string | undefined;
  NextPageToken?: string | undefined;
  MaxResults?: number | undefined;
}
export declare class DataUnavailableException extends __BaseException {
  readonly name: "DataUnavailableException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<DataUnavailableException, __BaseException>
  );
}
export declare const Granularity: {
  readonly DAILY: "DAILY";
  readonly HOURLY: "HOURLY";
  readonly MONTHLY: "MONTHLY";
};
export type Granularity = (typeof Granularity)[keyof typeof Granularity];
export interface GetApproximateUsageRecordsRequest {
  Granularity: Granularity | undefined;
  Services?: string[] | undefined;
  ApproximationDimension: ApproximationDimension | undefined;
}
export interface DateInterval {
  Start: string | undefined;
  End: string | undefined;
}
export interface GetApproximateUsageRecordsResponse {
  Services?: Record<string, number> | undefined;
  TotalRecords?: number | undefined;
  LookbackPeriod?: DateInterval | undefined;
}
export declare class BillExpirationException extends __BaseException {
  readonly name: "BillExpirationException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<BillExpirationException, __BaseException>
  );
}
export declare const GroupDefinitionType: {
  readonly COST_CATEGORY: "COST_CATEGORY";
  readonly DIMENSION: "DIMENSION";
  readonly TAG: "TAG";
};
export type GroupDefinitionType =
  (typeof GroupDefinitionType)[keyof typeof GroupDefinitionType];
export interface GroupDefinition {
  Type?: GroupDefinitionType | undefined;
  Key?: string | undefined;
}
export interface DimensionValuesWithAttributes {
  Value?: string | undefined;
  Attributes?: Record<string, string> | undefined;
}
export interface MetricValue {
  Amount?: string | undefined;
  Unit?: string | undefined;
}
export interface Group {
  Keys?: string[] | undefined;
  Metrics?: Record<string, MetricValue> | undefined;
}
export interface ResultByTime {
  TimePeriod?: DateInterval | undefined;
  Total?: Record<string, MetricValue> | undefined;
  Groups?: Group[] | undefined;
  Estimated?: boolean | undefined;
}
export interface GetCostAndUsageResponse {
  NextPageToken?: string | undefined;
  GroupDefinitions?: GroupDefinition[] | undefined;
  ResultsByTime?: ResultByTime[] | undefined;
  DimensionValueAttributes?: DimensionValuesWithAttributes[] | undefined;
}
export declare class RequestChangedException extends __BaseException {
  readonly name: "RequestChangedException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<RequestChangedException, __BaseException>
  );
}
export interface GetCostAndUsageWithResourcesResponse {
  NextPageToken?: string | undefined;
  GroupDefinitions?: GroupDefinition[] | undefined;
  ResultsByTime?: ResultByTime[] | undefined;
  DimensionValueAttributes?: DimensionValuesWithAttributes[] | undefined;
}
export declare const SortOrder: {
  readonly ASCENDING: "ASCENDING";
  readonly DESCENDING: "DESCENDING";
};
export type SortOrder = (typeof SortOrder)[keyof typeof SortOrder];
export interface SortDefinition {
  Key: string | undefined;
  SortOrder?: SortOrder | undefined;
}
export interface GetCostCategoriesResponse {
  NextPageToken?: string | undefined;
  CostCategoryNames?: string[] | undefined;
  CostCategoryValues?: string[] | undefined;
  ReturnSize: number | undefined;
  TotalSize: number | undefined;
}
export declare const Metric: {
  readonly AMORTIZED_COST: "AMORTIZED_COST";
  readonly BLENDED_COST: "BLENDED_COST";
  readonly NET_AMORTIZED_COST: "NET_AMORTIZED_COST";
  readonly NET_UNBLENDED_COST: "NET_UNBLENDED_COST";
  readonly NORMALIZED_USAGE_AMOUNT: "NORMALIZED_USAGE_AMOUNT";
  readonly UNBLENDED_COST: "UNBLENDED_COST";
  readonly USAGE_QUANTITY: "USAGE_QUANTITY";
};
export type Metric = (typeof Metric)[keyof typeof Metric];
export interface ForecastResult {
  TimePeriod?: DateInterval | undefined;
  MeanValue?: string | undefined;
  PredictionIntervalLowerBound?: string | undefined;
  PredictionIntervalUpperBound?: string | undefined;
}
export interface GetCostForecastResponse {
  Total?: MetricValue | undefined;
  ForecastResultsByTime?: ForecastResult[] | undefined;
}
export declare const Context: {
  readonly COST_AND_USAGE: "COST_AND_USAGE";
  readonly RESERVATIONS: "RESERVATIONS";
  readonly SAVINGS_PLANS: "SAVINGS_PLANS";
};
export type Context = (typeof Context)[keyof typeof Context];
export interface GetDimensionValuesResponse {
  DimensionValues: DimensionValuesWithAttributes[] | undefined;
  ReturnSize: number | undefined;
  TotalSize: number | undefined;
  NextPageToken?: string | undefined;
}
export interface CoverageCost {
  OnDemandCost?: string | undefined;
}
export interface CoverageHours {
  OnDemandHours?: string | undefined;
  ReservedHours?: string | undefined;
  TotalRunningHours?: string | undefined;
  CoverageHoursPercentage?: string | undefined;
}
export interface CoverageNormalizedUnits {
  OnDemandNormalizedUnits?: string | undefined;
  ReservedNormalizedUnits?: string | undefined;
  TotalRunningNormalizedUnits?: string | undefined;
  CoverageNormalizedUnitsPercentage?: string | undefined;
}
export interface Coverage {
  CoverageHours?: CoverageHours | undefined;
  CoverageNormalizedUnits?: CoverageNormalizedUnits | undefined;
  CoverageCost?: CoverageCost | undefined;
}
export interface ReservationCoverageGroup {
  Attributes?: Record<string, string> | undefined;
  Coverage?: Coverage | undefined;
}
export interface CoverageByTime {
  TimePeriod?: DateInterval | undefined;
  Groups?: ReservationCoverageGroup[] | undefined;
  Total?: Coverage | undefined;
}
export interface GetReservationCoverageResponse {
  CoveragesByTime: CoverageByTime[] | undefined;
  Total?: Coverage | undefined;
  NextPageToken?: string | undefined;
}
export declare const LookbackPeriodInDays: {
  readonly SEVEN_DAYS: "SEVEN_DAYS";
  readonly SIXTY_DAYS: "SIXTY_DAYS";
  readonly THIRTY_DAYS: "THIRTY_DAYS";
};
export type LookbackPeriodInDays =
  (typeof LookbackPeriodInDays)[keyof typeof LookbackPeriodInDays];
export declare const PaymentOption: {
  readonly ALL_UPFRONT: "ALL_UPFRONT";
  readonly HEAVY_UTILIZATION: "HEAVY_UTILIZATION";
  readonly LIGHT_UTILIZATION: "LIGHT_UTILIZATION";
  readonly MEDIUM_UTILIZATION: "MEDIUM_UTILIZATION";
  readonly NO_UPFRONT: "NO_UPFRONT";
  readonly PARTIAL_UPFRONT: "PARTIAL_UPFRONT";
};
export type PaymentOption = (typeof PaymentOption)[keyof typeof PaymentOption];
export declare const OfferingClass: {
  readonly CONVERTIBLE: "CONVERTIBLE";
  readonly STANDARD: "STANDARD";
};
export type OfferingClass = (typeof OfferingClass)[keyof typeof OfferingClass];
export interface EC2Specification {
  OfferingClass?: OfferingClass | undefined;
}
export interface ServiceSpecification {
  EC2Specification?: EC2Specification | undefined;
}
export declare const TermInYears: {
  readonly ONE_YEAR: "ONE_YEAR";
  readonly THREE_YEARS: "THREE_YEARS";
};
export type TermInYears = (typeof TermInYears)[keyof typeof TermInYears];
export interface ReservationPurchaseRecommendationMetadata {
  RecommendationId?: string | undefined;
  GenerationTimestamp?: string | undefined;
  AdditionalMetadata?: string | undefined;
}
export interface EC2InstanceDetails {
  Family?: string | undefined;
  InstanceType?: string | undefined;
  Region?: string | undefined;
  AvailabilityZone?: string | undefined;
  Platform?: string | undefined;
  Tenancy?: string | undefined;
  CurrentGeneration?: boolean | undefined;
  SizeFlexEligible?: boolean | undefined;
}
export interface ElastiCacheInstanceDetails {
  Family?: string | undefined;
  NodeType?: string | undefined;
  Region?: string | undefined;
  ProductDescription?: string | undefined;
  CurrentGeneration?: boolean | undefined;
  SizeFlexEligible?: boolean | undefined;
}
export interface ESInstanceDetails {
  InstanceClass?: string | undefined;
  InstanceSize?: string | undefined;
  Region?: string | undefined;
  CurrentGeneration?: boolean | undefined;
  SizeFlexEligible?: boolean | undefined;
}
export interface MemoryDBInstanceDetails {
  Family?: string | undefined;
  NodeType?: string | undefined;
  Region?: string | undefined;
  CurrentGeneration?: boolean | undefined;
  SizeFlexEligible?: boolean | undefined;
}
export interface RDSInstanceDetails {
  Family?: string | undefined;
  InstanceType?: string | undefined;
  Region?: string | undefined;
  DatabaseEngine?: string | undefined;
  DatabaseEdition?: string | undefined;
  DeploymentOption?: string | undefined;
  LicenseModel?: string | undefined;
  CurrentGeneration?: boolean | undefined;
  SizeFlexEligible?: boolean | undefined;
}
export interface RedshiftInstanceDetails {
  Family?: string | undefined;
  NodeType?: string | undefined;
  Region?: string | undefined;
  CurrentGeneration?: boolean | undefined;
  SizeFlexEligible?: boolean | undefined;
}
export interface InstanceDetails {
  EC2InstanceDetails?: EC2InstanceDetails | undefined;
  RDSInstanceDetails?: RDSInstanceDetails | undefined;
  RedshiftInstanceDetails?: RedshiftInstanceDetails | undefined;
  ElastiCacheInstanceDetails?: ElastiCacheInstanceDetails | undefined;
  ESInstanceDetails?: ESInstanceDetails | undefined;
  MemoryDBInstanceDetails?: MemoryDBInstanceDetails | undefined;
}
export interface DynamoDBCapacityDetails {
  CapacityUnits?: string | undefined;
  Region?: string | undefined;
}
export interface ReservedCapacityDetails {
  DynamoDBCapacityDetails?: DynamoDBCapacityDetails | undefined;
}
export interface ReservationPurchaseRecommendationDetail {
  AccountId?: string | undefined;
  InstanceDetails?: InstanceDetails | undefined;
  RecommendedNumberOfInstancesToPurchase?: string | undefined;
  RecommendedNormalizedUnitsToPurchase?: string | undefined;
  MinimumNumberOfInstancesUsedPerHour?: string | undefined;
  MinimumNormalizedUnitsUsedPerHour?: string | undefined;
  MaximumNumberOfInstancesUsedPerHour?: string | undefined;
  MaximumNormalizedUnitsUsedPerHour?: string | undefined;
  AverageNumberOfInstancesUsedPerHour?: string | undefined;
  AverageNormalizedUnitsUsedPerHour?: string | undefined;
  AverageUtilization?: string | undefined;
  EstimatedBreakEvenInMonths?: string | undefined;
  CurrencyCode?: string | undefined;
  EstimatedMonthlySavingsAmount?: string | undefined;
  EstimatedMonthlySavingsPercentage?: string | undefined;
  EstimatedMonthlyOnDemandCost?: string | undefined;
  EstimatedReservationCostForLookbackPeriod?: string | undefined;
  UpfrontCost?: string | undefined;
  RecurringStandardMonthlyCost?: string | undefined;
  ReservedCapacityDetails?: ReservedCapacityDetails | undefined;
  RecommendedNumberOfCapacityUnitsToPurchase?: string | undefined;
  MinimumNumberOfCapacityUnitsUsedPerHour?: string | undefined;
  MaximumNumberOfCapacityUnitsUsedPerHour?: string | undefined;
  AverageNumberOfCapacityUnitsUsedPerHour?: string | undefined;
}
export interface ReservationPurchaseRecommendationSummary {
  TotalEstimatedMonthlySavingsAmount?: string | undefined;
  TotalEstimatedMonthlySavingsPercentage?: string | undefined;
  CurrencyCode?: string | undefined;
}
export interface ReservationPurchaseRecommendation {
  AccountScope?: AccountScope | undefined;
  LookbackPeriodInDays?: LookbackPeriodInDays | undefined;
  TermInYears?: TermInYears | undefined;
  PaymentOption?: PaymentOption | undefined;
  ServiceSpecification?: ServiceSpecification | undefined;
  RecommendationDetails?: ReservationPurchaseRecommendationDetail[] | undefined;
  RecommendationSummary?: ReservationPurchaseRecommendationSummary | undefined;
}
export interface GetReservationPurchaseRecommendationResponse {
  Metadata?: ReservationPurchaseRecommendationMetadata | undefined;
  Recommendations?: ReservationPurchaseRecommendation[] | undefined;
  NextPageToken?: string | undefined;
}
export interface ReservationAggregates {
  UtilizationPercentage?: string | undefined;
  UtilizationPercentageInUnits?: string | undefined;
  PurchasedHours?: string | undefined;
  PurchasedUnits?: string | undefined;
  TotalActualHours?: string | undefined;
  TotalActualUnits?: string | undefined;
  UnusedHours?: string | undefined;
  UnusedUnits?: string | undefined;
  OnDemandCostOfRIHoursUsed?: string | undefined;
  NetRISavings?: string | undefined;
  TotalPotentialRISavings?: string | undefined;
  AmortizedUpfrontFee?: string | undefined;
  AmortizedRecurringFee?: string | undefined;
  TotalAmortizedFee?: string | undefined;
  RICostForUnusedHours?: string | undefined;
  RealizedSavings?: string | undefined;
  UnrealizedSavings?: string | undefined;
}
export interface ReservationUtilizationGroup {
  Key?: string | undefined;
  Value?: string | undefined;
  Attributes?: Record<string, string> | undefined;
  Utilization?: ReservationAggregates | undefined;
}
export interface UtilizationByTime {
  TimePeriod?: DateInterval | undefined;
  Groups?: ReservationUtilizationGroup[] | undefined;
  Total?: ReservationAggregates | undefined;
}
export interface GetReservationUtilizationResponse {
  UtilizationsByTime: UtilizationByTime[] | undefined;
  Total?: ReservationAggregates | undefined;
  NextPageToken?: string | undefined;
}
export declare const RecommendationTarget: {
  readonly CROSS_INSTANCE_FAMILY: "CROSS_INSTANCE_FAMILY";
  readonly SAME_INSTANCE_FAMILY: "SAME_INSTANCE_FAMILY";
};
export type RecommendationTarget =
  (typeof RecommendationTarget)[keyof typeof RecommendationTarget];
export interface RightsizingRecommendationConfiguration {
  RecommendationTarget: RecommendationTarget | undefined;
  BenefitsConsidered: boolean | undefined;
}
export interface RightsizingRecommendationMetadata {
  RecommendationId?: string | undefined;
  GenerationTimestamp?: string | undefined;
  LookbackPeriodInDays?: LookbackPeriodInDays | undefined;
  AdditionalMetadata?: string | undefined;
}
export interface EC2ResourceDetails {
  HourlyOnDemandRate?: string | undefined;
  InstanceType?: string | undefined;
  Platform?: string | undefined;
  Region?: string | undefined;
  Sku?: string | undefined;
  Memory?: string | undefined;
  NetworkPerformance?: string | undefined;
  Storage?: string | undefined;
  Vcpu?: string | undefined;
}
export interface ResourceDetails {
  EC2ResourceDetails?: EC2ResourceDetails | undefined;
}
export interface DiskResourceUtilization {
  DiskReadOpsPerSecond?: string | undefined;
  DiskWriteOpsPerSecond?: string | undefined;
  DiskReadBytesPerSecond?: string | undefined;
  DiskWriteBytesPerSecond?: string | undefined;
}
export interface EBSResourceUtilization {
  EbsReadOpsPerSecond?: string | undefined;
  EbsWriteOpsPerSecond?: string | undefined;
  EbsReadBytesPerSecond?: string | undefined;
  EbsWriteBytesPerSecond?: string | undefined;
}
export interface NetworkResourceUtilization {
  NetworkInBytesPerSecond?: string | undefined;
  NetworkOutBytesPerSecond?: string | undefined;
  NetworkPacketsInPerSecond?: string | undefined;
  NetworkPacketsOutPerSecond?: string | undefined;
}
export interface EC2ResourceUtilization {
  MaxCpuUtilizationPercentage?: string | undefined;
  MaxMemoryUtilizationPercentage?: string | undefined;
  MaxStorageUtilizationPercentage?: string | undefined;
  EBSResourceUtilization?: EBSResourceUtilization | undefined;
  DiskResourceUtilization?: DiskResourceUtilization | undefined;
  NetworkResourceUtilization?: NetworkResourceUtilization | undefined;
}
export interface ResourceUtilization {
  EC2ResourceUtilization?: EC2ResourceUtilization | undefined;
}
export interface CurrentInstance {
  ResourceId?: string | undefined;
  InstanceName?: string | undefined;
  Tags?: TagValues[] | undefined;
  ResourceDetails?: ResourceDetails | undefined;
  ResourceUtilization?: ResourceUtilization | undefined;
  ReservationCoveredHoursInLookbackPeriod?: string | undefined;
  SavingsPlansCoveredHoursInLookbackPeriod?: string | undefined;
  OnDemandHoursInLookbackPeriod?: string | undefined;
  TotalRunningHoursInLookbackPeriod?: string | undefined;
  MonthlyCost?: string | undefined;
  CurrencyCode?: string | undefined;
}
export declare const FindingReasonCode: {
  readonly CPU_OVER_PROVISIONED: "CPU_OVER_PROVISIONED";
  readonly CPU_UNDER_PROVISIONED: "CPU_UNDER_PROVISIONED";
  readonly DISK_IOPS_OVER_PROVISIONED: "DISK_IOPS_OVER_PROVISIONED";
  readonly DISK_IOPS_UNDER_PROVISIONED: "DISK_IOPS_UNDER_PROVISIONED";
  readonly DISK_THROUGHPUT_OVER_PROVISIONED: "DISK_THROUGHPUT_OVER_PROVISIONED";
  readonly DISK_THROUGHPUT_UNDER_PROVISIONED: "DISK_THROUGHPUT_UNDER_PROVISIONED";
  readonly EBS_IOPS_OVER_PROVISIONED: "EBS_IOPS_OVER_PROVISIONED";
  readonly EBS_IOPS_UNDER_PROVISIONED: "EBS_IOPS_UNDER_PROVISIONED";
  readonly EBS_THROUGHPUT_OVER_PROVISIONED: "EBS_THROUGHPUT_OVER_PROVISIONED";
  readonly EBS_THROUGHPUT_UNDER_PROVISIONED: "EBS_THROUGHPUT_UNDER_PROVISIONED";
  readonly MEMORY_OVER_PROVISIONED: "MEMORY_OVER_PROVISIONED";
  readonly MEMORY_UNDER_PROVISIONED: "MEMORY_UNDER_PROVISIONED";
  readonly NETWORK_BANDWIDTH_OVER_PROVISIONED: "NETWORK_BANDWIDTH_OVER_PROVISIONED";
  readonly NETWORK_BANDWIDTH_UNDER_PROVISIONED: "NETWORK_BANDWIDTH_UNDER_PROVISIONED";
  readonly NETWORK_PPS_OVER_PROVISIONED: "NETWORK_PPS_OVER_PROVISIONED";
  readonly NETWORK_PPS_UNDER_PROVISIONED: "NETWORK_PPS_UNDER_PROVISIONED";
};
export type FindingReasonCode =
  (typeof FindingReasonCode)[keyof typeof FindingReasonCode];
export declare const PlatformDifference: {
  readonly HYPERVISOR: "HYPERVISOR";
  readonly INSTANCE_STORE_AVAILABILITY: "INSTANCE_STORE_AVAILABILITY";
  readonly NETWORK_INTERFACE: "NETWORK_INTERFACE";
  readonly STORAGE_INTERFACE: "STORAGE_INTERFACE";
  readonly VIRTUALIZATION_TYPE: "VIRTUALIZATION_TYPE";
};
export type PlatformDifference =
  (typeof PlatformDifference)[keyof typeof PlatformDifference];
export interface TargetInstance {
  EstimatedMonthlyCost?: string | undefined;
  EstimatedMonthlySavings?: string | undefined;
  CurrencyCode?: string | undefined;
  DefaultTargetInstance?: boolean | undefined;
  ResourceDetails?: ResourceDetails | undefined;
  ExpectedResourceUtilization?: ResourceUtilization | undefined;
  PlatformDifferences?: PlatformDifference[] | undefined;
}
export interface ModifyRecommendationDetail {
  TargetInstances?: TargetInstance[] | undefined;
}
export declare const RightsizingType: {
  readonly MODIFY: "MODIFY";
  readonly TERMINATE: "TERMINATE";
};
export type RightsizingType =
  (typeof RightsizingType)[keyof typeof RightsizingType];
export interface TerminateRecommendationDetail {
  EstimatedMonthlySavings?: string | undefined;
  CurrencyCode?: string | undefined;
}
export interface RightsizingRecommendation {
  AccountId?: string | undefined;
  CurrentInstance?: CurrentInstance | undefined;
  RightsizingType?: RightsizingType | undefined;
  ModifyRecommendationDetail?: ModifyRecommendationDetail | undefined;
  TerminateRecommendationDetail?: TerminateRecommendationDetail | undefined;
  FindingReasonCodes?: FindingReasonCode[] | undefined;
}
export interface RightsizingRecommendationSummary {
  TotalRecommendationCount?: string | undefined;
  EstimatedTotalMonthlySavingsAmount?: string | undefined;
  SavingsCurrencyCode?: string | undefined;
  SavingsPercentage?: string | undefined;
}
export interface GetRightsizingRecommendationResponse {
  Metadata?: RightsizingRecommendationMetadata | undefined;
  Summary?: RightsizingRecommendationSummary | undefined;
  RightsizingRecommendations?: RightsizingRecommendation[] | undefined;
  NextPageToken?: string | undefined;
  Configuration?: RightsizingRecommendationConfiguration | undefined;
}
export interface GetSavingsPlanPurchaseRecommendationDetailsRequest {
  RecommendationDetailId: string | undefined;
}
export interface RecommendationDetailHourlyMetrics {
  StartTime?: string | undefined;
  EstimatedOnDemandCost?: string | undefined;
  CurrentCoverage?: string | undefined;
  EstimatedCoverage?: string | undefined;
  EstimatedNewCommitmentUtilization?: string | undefined;
}
export declare const SupportedSavingsPlansType: {
  readonly COMPUTE_SP: "COMPUTE_SP";
  readonly EC2_INSTANCE_SP: "EC2_INSTANCE_SP";
  readonly SAGEMAKER_SP: "SAGEMAKER_SP";
};
export type SupportedSavingsPlansType =
  (typeof SupportedSavingsPlansType)[keyof typeof SupportedSavingsPlansType];
export interface RecommendationDetailData {
  AccountScope?: AccountScope | undefined;
  LookbackPeriodInDays?: LookbackPeriodInDays | undefined;
  SavingsPlansType?: SupportedSavingsPlansType | undefined;
  TermInYears?: TermInYears | undefined;
  PaymentOption?: PaymentOption | undefined;
  AccountId?: string | undefined;
  CurrencyCode?: string | undefined;
  InstanceFamily?: string | undefined;
  Region?: string | undefined;
  OfferingId?: string | undefined;
  GenerationTimestamp?: string | undefined;
  LatestUsageTimestamp?: string | undefined;
  CurrentAverageHourlyOnDemandSpend?: string | undefined;
  CurrentMaximumHourlyOnDemandSpend?: string | undefined;
  CurrentMinimumHourlyOnDemandSpend?: string | undefined;
  EstimatedAverageUtilization?: string | undefined;
  EstimatedMonthlySavingsAmount?: string | undefined;
  EstimatedOnDemandCost?: string | undefined;
  EstimatedOnDemandCostWithCurrentCommitment?: string | undefined;
  EstimatedROI?: string | undefined;
  EstimatedSPCost?: string | undefined;
  EstimatedSavingsAmount?: string | undefined;
  EstimatedSavingsPercentage?: string | undefined;
  ExistingHourlyCommitment?: string | undefined;
  HourlyCommitmentToPurchase?: string | undefined;
  UpfrontCost?: string | undefined;
  CurrentAverageCoverage?: string | undefined;
  EstimatedAverageCoverage?: string | undefined;
  MetricsOverLookbackPeriod?: RecommendationDetailHourlyMetrics[] | undefined;
}
export interface GetSavingsPlanPurchaseRecommendationDetailsResponse {
  RecommendationDetailId?: string | undefined;
  RecommendationDetailData?: RecommendationDetailData | undefined;
}
export interface SavingsPlansCoverageData {
  SpendCoveredBySavingsPlans?: string | undefined;
  OnDemandCost?: string | undefined;
  TotalCost?: string | undefined;
  CoveragePercentage?: string | undefined;
}
export interface SavingsPlansCoverage {
  Attributes?: Record<string, string> | undefined;
  Coverage?: SavingsPlansCoverageData | undefined;
  TimePeriod?: DateInterval | undefined;
}
export interface GetSavingsPlansCoverageResponse {
  SavingsPlansCoverages: SavingsPlansCoverage[] | undefined;
  NextToken?: string | undefined;
}
export interface SavingsPlansPurchaseRecommendationMetadata {
  RecommendationId?: string | undefined;
  GenerationTimestamp?: string | undefined;
  AdditionalMetadata?: string | undefined;
}
export interface SavingsPlansDetails {
  Region?: string | undefined;
  InstanceFamily?: string | undefined;
  OfferingId?: string | undefined;
}
export interface SavingsPlansPurchaseRecommendationDetail {
  SavingsPlansDetails?: SavingsPlansDetails | undefined;
  AccountId?: string | undefined;
  UpfrontCost?: string | undefined;
  EstimatedROI?: string | undefined;
  CurrencyCode?: string | undefined;
  EstimatedSPCost?: string | undefined;
  EstimatedOnDemandCost?: string | undefined;
  EstimatedOnDemandCostWithCurrentCommitment?: string | undefined;
  EstimatedSavingsAmount?: string | undefined;
  EstimatedSavingsPercentage?: string | undefined;
  HourlyCommitmentToPurchase?: string | undefined;
  EstimatedAverageUtilization?: string | undefined;
  EstimatedMonthlySavingsAmount?: string | undefined;
  CurrentMinimumHourlyOnDemandSpend?: string | undefined;
  CurrentMaximumHourlyOnDemandSpend?: string | undefined;
  CurrentAverageHourlyOnDemandSpend?: string | undefined;
  RecommendationDetailId?: string | undefined;
}
export interface SavingsPlansPurchaseRecommendationSummary {
  EstimatedROI?: string | undefined;
  CurrencyCode?: string | undefined;
  EstimatedTotalCost?: string | undefined;
  CurrentOnDemandSpend?: string | undefined;
  EstimatedSavingsAmount?: string | undefined;
  TotalRecommendationCount?: string | undefined;
  DailyCommitmentToPurchase?: string | undefined;
  HourlyCommitmentToPurchase?: string | undefined;
  EstimatedSavingsPercentage?: string | undefined;
  EstimatedMonthlySavingsAmount?: string | undefined;
  EstimatedOnDemandCostWithCurrentCommitment?: string | undefined;
}
export interface SavingsPlansPurchaseRecommendation {
  AccountScope?: AccountScope | undefined;
  SavingsPlansType?: SupportedSavingsPlansType | undefined;
  TermInYears?: TermInYears | undefined;
  PaymentOption?: PaymentOption | undefined;
  LookbackPeriodInDays?: LookbackPeriodInDays | undefined;
  SavingsPlansPurchaseRecommendationDetails?:
    | SavingsPlansPurchaseRecommendationDetail[]
    | undefined;
  SavingsPlansPurchaseRecommendationSummary?:
    | SavingsPlansPurchaseRecommendationSummary
    | undefined;
}
export interface GetSavingsPlansPurchaseRecommendationResponse {
  Metadata?: SavingsPlansPurchaseRecommendationMetadata | undefined;
  SavingsPlansPurchaseRecommendation?:
    | SavingsPlansPurchaseRecommendation
    | undefined;
  NextPageToken?: string | undefined;
}
export interface SavingsPlansAmortizedCommitment {
  AmortizedRecurringCommitment?: string | undefined;
  AmortizedUpfrontCommitment?: string | undefined;
  TotalAmortizedCommitment?: string | undefined;
}
export interface SavingsPlansSavings {
  NetSavings?: string | undefined;
  OnDemandCostEquivalent?: string | undefined;
}
export interface SavingsPlansUtilization {
  TotalCommitment?: string | undefined;
  UsedCommitment?: string | undefined;
  UnusedCommitment?: string | undefined;
  UtilizationPercentage?: string | undefined;
}
export interface SavingsPlansUtilizationByTime {
  TimePeriod: DateInterval | undefined;
  Utilization: SavingsPlansUtilization | undefined;
  Savings?: SavingsPlansSavings | undefined;
  AmortizedCommitment?: SavingsPlansAmortizedCommitment | undefined;
}
export interface SavingsPlansUtilizationAggregates {
  Utilization: SavingsPlansUtilization | undefined;
  Savings?: SavingsPlansSavings | undefined;
  AmortizedCommitment?: SavingsPlansAmortizedCommitment | undefined;
}
export interface GetSavingsPlansUtilizationResponse {
  SavingsPlansUtilizationsByTime?: SavingsPlansUtilizationByTime[] | undefined;
  Total: SavingsPlansUtilizationAggregates | undefined;
}
export declare const SavingsPlansDataType: {
  readonly AMORTIZED_COMMITMENT: "AMORTIZED_COMMITMENT";
  readonly ATTRIBUTES: "ATTRIBUTES";
  readonly SAVINGS: "SAVINGS";
  readonly UTILIZATION: "UTILIZATION";
};
export type SavingsPlansDataType =
  (typeof SavingsPlansDataType)[keyof typeof SavingsPlansDataType];
export interface SavingsPlansUtilizationDetail {
  SavingsPlanArn?: string | undefined;
  Attributes?: Record<string, string> | undefined;
  Utilization?: SavingsPlansUtilization | undefined;
  Savings?: SavingsPlansSavings | undefined;
  AmortizedCommitment?: SavingsPlansAmortizedCommitment | undefined;
}
export interface GetSavingsPlansUtilizationDetailsResponse {
  SavingsPlansUtilizationDetails: SavingsPlansUtilizationDetail[] | undefined;
  Total?: SavingsPlansUtilizationAggregates | undefined;
  TimePeriod: DateInterval | undefined;
  NextToken?: string | undefined;
}
export interface GetTagsResponse {
  NextPageToken?: string | undefined;
  Tags: string[] | undefined;
  ReturnSize: number | undefined;
  TotalSize: number | undefined;
}
export interface GetUsageForecastResponse {
  Total?: MetricValue | undefined;
  ForecastResultsByTime?: ForecastResult[] | undefined;
}
export declare class UnresolvableUsageUnitException extends __BaseException {
  readonly name: "UnresolvableUsageUnitException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<UnresolvableUsageUnitException, __BaseException>
  );
}
export interface ListCostAllocationTagBackfillHistoryRequest {
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export declare const CostAllocationTagBackfillStatus: {
  readonly FAILED: "FAILED";
  readonly PROCESSING: "PROCESSING";
  readonly SUCCEEDED: "SUCCEEDED";
};
export type CostAllocationTagBackfillStatus =
  (typeof CostAllocationTagBackfillStatus)[keyof typeof CostAllocationTagBackfillStatus];
export interface CostAllocationTagBackfillRequest {
  BackfillFrom?: string | undefined;
  RequestedAt?: string | undefined;
  CompletedAt?: string | undefined;
  BackfillStatus?: CostAllocationTagBackfillStatus | undefined;
  LastUpdatedAt?: string | undefined;
}
export interface ListCostAllocationTagBackfillHistoryResponse {
  BackfillRequests?: CostAllocationTagBackfillRequest[] | undefined;
  NextToken?: string | undefined;
}
export declare const CostAllocationTagStatus: {
  readonly ACTIVE: "Active";
  readonly INACTIVE: "Inactive";
};
export type CostAllocationTagStatus =
  (typeof CostAllocationTagStatus)[keyof typeof CostAllocationTagStatus];
export declare const CostAllocationTagType: {
  readonly AWS_GENERATED: "AWSGenerated";
  readonly USER_DEFINED: "UserDefined";
};
export type CostAllocationTagType =
  (typeof CostAllocationTagType)[keyof typeof CostAllocationTagType];
export interface ListCostAllocationTagsRequest {
  Status?: CostAllocationTagStatus | undefined;
  TagKeys?: string[] | undefined;
  Type?: CostAllocationTagType | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export interface CostAllocationTag {
  TagKey: string | undefined;
  Type: CostAllocationTagType | undefined;
  Status: CostAllocationTagStatus | undefined;
  LastUpdatedDate?: string | undefined;
  LastUsedDate?: string | undefined;
}
export interface ListCostAllocationTagsResponse {
  CostAllocationTags?: CostAllocationTag[] | undefined;
  NextToken?: string | undefined;
}
export interface ListCostCategoryDefinitionsRequest {
  EffectiveOn?: string | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
}
export interface CostCategoryReference {
  CostCategoryArn?: string | undefined;
  Name?: string | undefined;
  EffectiveStart?: string | undefined;
  EffectiveEnd?: string | undefined;
  NumberOfRules?: number | undefined;
  ProcessingStatus?: CostCategoryProcessingStatus[] | undefined;
  Values?: string[] | undefined;
  DefaultValue?: string | undefined;
}
export interface ListCostCategoryDefinitionsResponse {
  CostCategoryReferences?: CostCategoryReference[] | undefined;
  NextToken?: string | undefined;
}
export declare const GenerationStatus: {
  readonly FAILED: "FAILED";
  readonly PROCESSING: "PROCESSING";
  readonly SUCCEEDED: "SUCCEEDED";
};
export type GenerationStatus =
  (typeof GenerationStatus)[keyof typeof GenerationStatus];
export interface ListSavingsPlansPurchaseRecommendationGenerationRequest {
  GenerationStatus?: GenerationStatus | undefined;
  RecommendationIds?: string[] | undefined;
  PageSize?: number | undefined;
  NextPageToken?: string | undefined;
}
export interface GenerationSummary {
  RecommendationId?: string | undefined;
  GenerationStatus?: GenerationStatus | undefined;
  GenerationStartedTime?: string | undefined;
  GenerationCompletionTime?: string | undefined;
  EstimatedCompletionTime?: string | undefined;
}
export interface ListSavingsPlansPurchaseRecommendationGenerationResponse {
  GenerationSummaryList?: GenerationSummary[] | undefined;
  NextPageToken?: string | undefined;
}
export interface ListTagsForResourceRequest {
  ResourceArn: string | undefined;
}
export interface ListTagsForResourceResponse {
  ResourceTags?: ResourceTag[] | undefined;
}
export interface ProvideAnomalyFeedbackRequest {
  AnomalyId: string | undefined;
  Feedback: AnomalyFeedbackType | undefined;
}
export interface ProvideAnomalyFeedbackResponse {
  AnomalyId: string | undefined;
}
export declare class BackfillLimitExceededException extends __BaseException {
  readonly name: "BackfillLimitExceededException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<BackfillLimitExceededException, __BaseException>
  );
}
export interface StartCostAllocationTagBackfillRequest {
  BackfillFrom: string | undefined;
}
export interface StartCostAllocationTagBackfillResponse {
  BackfillRequest?: CostAllocationTagBackfillRequest | undefined;
}
export declare class GenerationExistsException extends __BaseException {
  readonly name: "GenerationExistsException";
  readonly $fault: "client";
  Message?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<GenerationExistsException, __BaseException>
  );
}
export interface StartSavingsPlansPurchaseRecommendationGenerationRequest {}
export interface StartSavingsPlansPurchaseRecommendationGenerationResponse {
  RecommendationId?: string | undefined;
  GenerationStartedTime?: string | undefined;
  EstimatedCompletionTime?: string | undefined;
}
export interface TagResourceRequest {
  ResourceArn: string | undefined;
  ResourceTags: ResourceTag[] | undefined;
}
export interface TagResourceResponse {}
export declare class TooManyTagsException extends __BaseException {
  readonly name: "TooManyTagsException";
  readonly $fault: "client";
  Message?: string | undefined;
  ResourceName?: string | undefined;
  constructor(
    opts: __ExceptionOptionType<TooManyTagsException, __BaseException>
  );
}
export interface UntagResourceRequest {
  ResourceArn: string | undefined;
  ResourceTagKeys: string[] | undefined;
}
export interface UntagResourceResponse {}
export interface UpdateAnomalyMonitorRequest {
  MonitorArn: string | undefined;
  MonitorName?: string | undefined;
}
export interface UpdateAnomalyMonitorResponse {
  MonitorArn: string | undefined;
}
export interface UpdateAnomalySubscriptionResponse {
  SubscriptionArn: string | undefined;
}
export interface CostAllocationTagStatusEntry {
  TagKey: string | undefined;
  Status: CostAllocationTagStatus | undefined;
}
export interface UpdateCostAllocationTagsStatusRequest {
  CostAllocationTagsStatus: CostAllocationTagStatusEntry[] | undefined;
}
export interface UpdateCostAllocationTagsStatusError {
  TagKey?: string | undefined;
  Code?: string | undefined;
  Message?: string | undefined;
}
export interface UpdateCostAllocationTagsStatusResponse {
  Errors?: UpdateCostAllocationTagsStatusError[] | undefined;
}
export interface UpdateCostCategoryDefinitionResponse {
  CostCategoryArn?: string | undefined;
  EffectiveStart?: string | undefined;
}
export interface Expression {
  Or?: Expression[] | undefined;
  And?: Expression[] | undefined;
  Not?: Expression | undefined;
  Dimensions?: DimensionValues | undefined;
  Tags?: TagValues | undefined;
  CostCategories?: CostCategoryValues | undefined;
}
export interface AnomalyMonitor {
  MonitorArn?: string | undefined;
  MonitorName: string | undefined;
  CreationDate?: string | undefined;
  LastUpdatedDate?: string | undefined;
  LastEvaluatedDate?: string | undefined;
  MonitorType: MonitorType | undefined;
  MonitorDimension?: MonitorDimension | undefined;
  MonitorSpecification?: Expression | undefined;
  DimensionalValueCount?: number | undefined;
}
export interface AnomalySubscription {
  SubscriptionArn?: string | undefined;
  AccountId?: string | undefined;
  MonitorArnList: string[] | undefined;
  Subscribers: Subscriber[] | undefined;
  Threshold?: number | undefined;
  Frequency: AnomalySubscriptionFrequency | undefined;
  SubscriptionName: string | undefined;
  ThresholdExpression?: Expression | undefined;
}
export interface CostCategoryRule {
  Value?: string | undefined;
  Rule?: Expression | undefined;
  InheritedValue?: CostCategoryInheritedValueDimension | undefined;
  Type?: CostCategoryRuleType | undefined;
}
export interface GetCostAndUsageRequest {
  TimePeriod: DateInterval | undefined;
  Granularity: Granularity | undefined;
  Filter?: Expression | undefined;
  Metrics: string[] | undefined;
  GroupBy?: GroupDefinition[] | undefined;
  NextPageToken?: string | undefined;
}
export interface GetCostAndUsageWithResourcesRequest {
  TimePeriod: DateInterval | undefined;
  Granularity: Granularity | undefined;
  Filter: Expression | undefined;
  Metrics?: string[] | undefined;
  GroupBy?: GroupDefinition[] | undefined;
  NextPageToken?: string | undefined;
}
export interface GetCostCategoriesRequest {
  SearchString?: string | undefined;
  TimePeriod: DateInterval | undefined;
  CostCategoryName?: string | undefined;
  Filter?: Expression | undefined;
  SortBy?: SortDefinition[] | undefined;
  MaxResults?: number | undefined;
  NextPageToken?: string | undefined;
}
export interface GetCostForecastRequest {
  TimePeriod: DateInterval | undefined;
  Metric: Metric | undefined;
  Granularity: Granularity | undefined;
  Filter?: Expression | undefined;
  PredictionIntervalLevel?: number | undefined;
}
export interface GetDimensionValuesRequest {
  SearchString?: string | undefined;
  TimePeriod: DateInterval | undefined;
  Dimension: Dimension | undefined;
  Context?: Context | undefined;
  Filter?: Expression | undefined;
  SortBy?: SortDefinition[] | undefined;
  MaxResults?: number | undefined;
  NextPageToken?: string | undefined;
}
export interface GetReservationCoverageRequest {
  TimePeriod: DateInterval | undefined;
  GroupBy?: GroupDefinition[] | undefined;
  Granularity?: Granularity | undefined;
  Filter?: Expression | undefined;
  Metrics?: string[] | undefined;
  NextPageToken?: string | undefined;
  SortBy?: SortDefinition | undefined;
  MaxResults?: number | undefined;
}
export interface GetReservationPurchaseRecommendationRequest {
  AccountId?: string | undefined;
  Service: string | undefined;
  Filter?: Expression | undefined;
  AccountScope?: AccountScope | undefined;
  LookbackPeriodInDays?: LookbackPeriodInDays | undefined;
  TermInYears?: TermInYears | undefined;
  PaymentOption?: PaymentOption | undefined;
  ServiceSpecification?: ServiceSpecification | undefined;
  PageSize?: number | undefined;
  NextPageToken?: string | undefined;
}
export interface GetReservationUtilizationRequest {
  TimePeriod: DateInterval | undefined;
  GroupBy?: GroupDefinition[] | undefined;
  Granularity?: Granularity | undefined;
  Filter?: Expression | undefined;
  SortBy?: SortDefinition | undefined;
  NextPageToken?: string | undefined;
  MaxResults?: number | undefined;
}
export interface GetRightsizingRecommendationRequest {
  Filter?: Expression | undefined;
  Configuration?: RightsizingRecommendationConfiguration | undefined;
  Service: string | undefined;
  PageSize?: number | undefined;
  NextPageToken?: string | undefined;
}
export interface GetSavingsPlansCoverageRequest {
  TimePeriod: DateInterval | undefined;
  GroupBy?: GroupDefinition[] | undefined;
  Granularity?: Granularity | undefined;
  Filter?: Expression | undefined;
  Metrics?: string[] | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
  SortBy?: SortDefinition | undefined;
}
export interface GetSavingsPlansPurchaseRecommendationRequest {
  SavingsPlansType: SupportedSavingsPlansType | undefined;
  TermInYears: TermInYears | undefined;
  PaymentOption: PaymentOption | undefined;
  AccountScope?: AccountScope | undefined;
  NextPageToken?: string | undefined;
  PageSize?: number | undefined;
  LookbackPeriodInDays: LookbackPeriodInDays | undefined;
  Filter?: Expression | undefined;
}
export interface GetSavingsPlansUtilizationDetailsRequest {
  TimePeriod: DateInterval | undefined;
  Filter?: Expression | undefined;
  DataType?: SavingsPlansDataType[] | undefined;
  NextToken?: string | undefined;
  MaxResults?: number | undefined;
  SortBy?: SortDefinition | undefined;
}
export interface GetSavingsPlansUtilizationRequest {
  TimePeriod: DateInterval | undefined;
  Granularity?: Granularity | undefined;
  Filter?: Expression | undefined;
  SortBy?: SortDefinition | undefined;
}
export interface GetTagsRequest {
  SearchString?: string | undefined;
  TimePeriod: DateInterval | undefined;
  TagKey?: string | undefined;
  Filter?: Expression | undefined;
  SortBy?: SortDefinition[] | undefined;
  MaxResults?: number | undefined;
  NextPageToken?: string | undefined;
}
export interface GetUsageForecastRequest {
  TimePeriod: DateInterval | undefined;
  Metric: Metric | undefined;
  Granularity: Granularity | undefined;
  Filter?: Expression | undefined;
  PredictionIntervalLevel?: number | undefined;
}
export interface UpdateAnomalySubscriptionRequest {
  SubscriptionArn: string | undefined;
  Threshold?: number | undefined;
  Frequency?: AnomalySubscriptionFrequency | undefined;
  MonitorArnList?: string[] | undefined;
  Subscribers?: Subscriber[] | undefined;
  SubscriptionName?: string | undefined;
  ThresholdExpression?: Expression | undefined;
}
export interface CreateAnomalyMonitorRequest {
  AnomalyMonitor: AnomalyMonitor | undefined;
  ResourceTags?: ResourceTag[] | undefined;
}
export interface CreateAnomalySubscriptionRequest {
  AnomalySubscription: AnomalySubscription | undefined;
  ResourceTags?: ResourceTag[] | undefined;
}
export interface CostCategory {
  CostCategoryArn: string | undefined;
  EffectiveStart: string | undefined;
  EffectiveEnd?: string | undefined;
  Name: string | undefined;
  RuleVersion: CostCategoryRuleVersion | undefined;
  Rules: CostCategoryRule[] | undefined;
  SplitChargeRules?: CostCategorySplitChargeRule[] | undefined;
  ProcessingStatus?: CostCategoryProcessingStatus[] | undefined;
  DefaultValue?: string | undefined;
}
export interface CreateCostCategoryDefinitionRequest {
  Name: string | undefined;
  EffectiveStart?: string | undefined;
  RuleVersion: CostCategoryRuleVersion | undefined;
  Rules: CostCategoryRule[] | undefined;
  DefaultValue?: string | undefined;
  SplitChargeRules?: CostCategorySplitChargeRule[] | undefined;
  ResourceTags?: ResourceTag[] | undefined;
}
export interface GetAnomalyMonitorsResponse {
  AnomalyMonitors: AnomalyMonitor[] | undefined;
  NextPageToken?: string | undefined;
}
export interface GetAnomalySubscriptionsResponse {
  AnomalySubscriptions: AnomalySubscription[] | undefined;
  NextPageToken?: string | undefined;
}
export interface UpdateCostCategoryDefinitionRequest {
  CostCategoryArn: string | undefined;
  EffectiveStart?: string | undefined;
  RuleVersion: CostCategoryRuleVersion | undefined;
  Rules: CostCategoryRule[] | undefined;
  DefaultValue?: string | undefined;
  SplitChargeRules?: CostCategorySplitChargeRule[] | undefined;
}
export interface DescribeCostCategoryDefinitionResponse {
  CostCategory?: CostCategory | undefined;
}
