import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
} from "@smithy/types";
import { SSOAdminClientResolvedConfig } from "../SSOAdminClient";
export interface SSOAdminHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface SSOAdminHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    SSOAdminClientResolvedConfig,
    HandlerExecutionContext,
    SSOAdminHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultSSOAdminHttpAuthSchemeParametersProvider: (
  config: SSOAdminClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<SSOAdminHttpAuthSchemeParameters>;
export interface SSOAdminHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<SSOAdminHttpAuthSchemeParameters> {}
export declare const defaultSSOAdminHttpAuthSchemeProvider: SSOAdminHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: SSOAdminHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: SSOAdminHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
